<template>
  <div class="primary-filter">
    <input
      :id="`calendar-toggle-${_uid}`"
      v-model="datePickerActive"
      class="d-none calendar-toggle"
      type="checkbox"
    />
    <div class="primary-filter__header text-left">
      <div class="flex">
        <div class="flex-5">
          <label class="filter-label">{{ $t("filters.numOfPersons") }}</label>
          <div class="picker-control-wrapper">
            <select v-model="numOfPersons" class="picker-control">
              <option v-for="n in maxSize" :value="n"
                >{{ n }} {{ $t("filters.personUnit") }}</option
              >
            </select>
          </div>
        </div>
        <div class="filter-date-column flex-7 ml-2">
          <label class="filter-label">{{ $t("filters.date") }}</label>
          <div
            class="picker-control-wrapper picker-control-wrapper--datepicker"
          >
            <label
              :for="`calendar-toggle-${_uid}`"
              class="picker-control calendar-toggle-trigger"
            >
              {{ date | displayDate }}
            </label>
          </div>
        </div>
      </div>
    </div>
    <div class="calendar-box">
      <date-picker :locale="$i18n.locale" v-model="date" />
    </div>
  </div>
</template>
<script>
import { mapState, mapActions } from "vuex";
import DatePicker from "@/components/DatePicker";

export default {
  data() {
    return {
      datePickerActive: false
    };
  },
  components: {
    DatePicker
  },
  watch: {
    date() {
      this.datePickerActive = false;
    }
  },
  computed: {
    date: {
      get() {
        return this.$store.state.group.filter.date;
      },
      set(date) {
        this.clearRestaurants();
        this.updateFilter({ date });
      }
    },
    numOfPersons: {
      get() {
        return this.$store.state.group.filter.numOfPersons;
      },
      set(numOfPersons) {
        this.updateFilter({ numOfPersons });
      }
    },
    maxSize() {
      const restaurants = this.$store.state.group.restaurants;
      if (restaurants.length) {
        return Math.max.apply(
          null,
          restaurants.map(r => r.maxBookingGroupSize)
        );
      }
      return 10;
    }
  },
  methods: {
    ...mapActions("group", ["updateFilter", "loadGroup", "clearRestaurants"])
  }
};
</script>
<style lang="scss" scoped>
.primary-filter {
  background-color: rgba(255, 255, 255, 0.92);
  box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.05);
  border-radius: 4px;
  overflow: hidden;
  color: $color-secondary-black;
  text-align: left;
}

.primary-filter__header {
  padding: 0.75em 1em;
}

.calendar-box {
  background-color: $color-white;
  max-height: 0;
  overflow: hidden;
  transition: max-height 0.5s cubic-bezier(0, 1, 0, 1);
}

.calendar-toggle:checked {
  & ~ .calendar-box {
    max-height: 1000px;
    transition: max-height 1s ease-in-out;
  }

  & ~ .primary-filter__header {
    .picker-control-wrapper--datepicker:after {
      color: $color-white;
      transform: translateY(-50%) rotate(180deg);
    }

    .calendar-toggle-trigger {
      background-color: $color-skm-red;
      color: $color-white;
    }
  }
}

.fixed-top-filter {
  .primary-filter {
    border-radius: 0;
    border-bottom: 1px solid $color-silver-grey;
  }
  .filter-label {
    display: none;
  }
}

.filter-date-column {
  flex-basis: 60px;
}
</style>
